version: '2.2'

services:

  # External dependencies
  redis:
    image: redis:alpine
    restart: ${RESTART_POLICY}
    volumes:
      - "${INSTALLATION_DIR}/redis:/data"
    
  # Core services
  front:
    image: mailu/nginx:${MAILU_VERSION}
    restart: ${RESTART_POLICY}
    env_file: mailu.env
    logging:
      driver: json-file
    ports:
      - "25:25"    # SMTP
      - "80:80"    # WEB
      - "110:110"  # POP3
      - "143:143"  # IMAP
      - "443:443"  # WEB TLS   
      - "465:465"  # SMTPS
      - "587:587"  # Submission
      - "993:993"  # IMAPS
      - "995:995"  # POP3s
    volumes:
      - "${INSTALLATION_DIR}/certs:/certs"
      - "${INSTALLATION_DIR}/overrides/nginx:/overrides"

{% if outbound_enabled is sameas true %}
  resolver:
    image: mailu/unbound:${MAILU_VERSION}
    env_file: mailu.env
    restart: ${RESTART_POLICY}
    networks:
      default:
        ipv4_address: {{ outbound_ip }}
{% endif %}

  admin:
    image: mailu/admin:${MAILU_VERSION}
    restart: ${RESTART_POLICY}
    env_file: mailu.env
    ports:
      - 127.0.0.1:8080:80
    volumes:
      - "${INSTALLATION_DIR}/data:/data"
      - "${INSTALLATION_DIR}/dkim:/dkim"
    depends_on:
      - redis

  imap:
    image: mailu/dovecot:${MAILU_VERSION}
    restart: ${RESTART_POLICY}
    env_file: mailu.env
    volumes:
      - "${INSTALLATION_DIR}/mail:/mail"
      - "${INSTALLATION_DIR}/overrides:/overrides"
    depends_on:
      - front

  smtp:
    image: mailu/postfix:${MAILU_VERSION}
    restart: ${RESTART_POLICY}
    env_file: mailu.env
    volumes:
      - "${INSTALLATION_DIR}/overrides:/overrides"
{% if outbound_enabled is sameas true %}
    depends_on:
      - front
      - resolver
    dns:
      - {{ outbound_ip }}
{% else %}
    depends_on:
      - front
{% endif %}

  antispam:
    image: mailu/rspamd:${MAILU_VERSION}
    restart: ${RESTART_POLICY}
    env_file: mailu.env
    ports:
      - 127.0.0.1:8081:11334
    volumes:
      - "${INSTALLATION_DIR}/filter:/var/lib/rspamd"
      - "${INSTALLATION_DIR}/dkim:/dkim"
      - "${INSTALLATION_DIR}/overrides/rspamd:/etc/rspamd/override.d"
{% if outbound_enabled is sameas true %}
    depends_on:
      - front
      - resolver
    dns:
      - {{ outbound_ip }}
{% else %}
    depends_on:
      - front
{% endif %}

  # Optional services
{% if antivirus_enabled is sameas true %}
  antivirus:
    image: mailu/clamav:${MAILU_VERSION}
    restart: ${RESTART_POLICY}
    env_file: mailu.env
    volumes:
      - "${INSTALLATION_DIR}/filter:/data"
{% if outbound_enabled is sameas true %}
    depends_on:
      - resolver
    dns:
      - {{ outbound_ip }}
{% endif %} {# outbound_enabled #}
{% endif %} {# antivirus_enabled #}

  webdav:
    image: mailu/radicale:${MAILU_VERSION}
    restart: ${RESTART_POLICY}
    env_file: mailu.env
    volumes:
      - "${INSTALLATION_DIR}/dav:/data"

  fetchmail:
    image: mailu/fetchmail:${MAILU_VERSION}
    restart: ${RESTART_POLICY}
    env_file: mailu.env
{% if outbound_enabled is sameas true %}
    depends_on:
      - resolver
    dns:
      - {{ outbound_ip }}
{% endif %}

  # Webmail
  webmail:
    image: mailu/rainloop:${MAILU_VERSION}
    restart: ${RESTART_POLICY}
    env_file: mailu.env
    volumes:
      - "${INSTALLATION_DIR}/webmail:/data"
    depends_on:
      - imap

  database:
    image: mailu/postgresql:${MAILU_VERSION}
    restart: ${RESTART_POLICY}
    env_file: mailu.env
    volumes:
      - "${INSTALLATION_DIR}/data/psql_db:/data"
      - "${INSTALLATION_DIR}/data/psql_backup:/backup"

networks:
  default:
    driver: bridge
    ipam:
      driver: default
      config:
        - subnet: {{ docker_network_subnet }}
